/*
Copyright (C) 2000-2004  The PARI group.

This file is part of the PARI/GP package.

PARI/GP is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software
Foundation. It is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY WHATSOEVER.

Check the License for details. You should have received a copy of it, along
with the package; see the file 'COPYING'. If not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

BEGINEXTERN

typedef enum {Fseq,
	      Fmatrix,FmatrixL,FmatrixR,
	      Faffect,
	      Ffacteurmat,
	      Fmatrixelts,Fmatrixlines,
	      Fmat,Fvec,Fnoarg,
	      Flistarg,
	      Frefarg,
	      Fconst,Fsmall,
	      Ftag,
	      Fentry,Ffunction,Fderfunc,Fdeffunc,
} Ffunc;

#define Flastfunc  (Fdeffunc)
#define FneedENTRY (Fconst)

/*see parse.y for definition.
Fblock x: block number y:seq
Fgnil   : it's a noop, but if evaluated leads to 0.
*/
typedef struct node_s
{
  Ffunc f;          /*node function*/
  long x;            /*node left child*/
  long y;            /*node right child*/
  char *start;
  char *end;
} node;

typedef enum {CSTstr, CSTquote, CSTgen, CSTreal} CSTtype;

typedef struct
{
  CSTtype type;     /*type of data*/
  GEN gen;
} value_t;

typedef enum {OPor, OPand, OPeq, OPne, OPge, OPg, OPle, OPl, OPs, OPp, OPsl, OPsr, OPmod, OPdr, OPeuc, OPd, OPm, OPpow, OPcat, OPstore, OPss, OPpp, OPse ,OPpe ,OPsle ,OPsre ,OPmode ,OPdre ,OPeuce ,OPde ,OPme, OPpl, OPn, OPnb, OPfact, OPderiv, OPtrans, OPhist, OPlength, OPnboperator} OPerator;

extern node *tree;
extern value_t *value;

long newnode(Ffunc f, long x, long y, struct node_loc*);
long newgennode(GEN g, struct node_loc*);
long newgenvalue(GEN g);
long newstringvalue(struct node_loc*);
long newquotevalue(struct node_loc*);
long newentry(struct node_loc*);
long newmember(struct node_loc*);
long newopcall(OPerator s, long x, long y, struct node_loc*);

ENDEXTERN
